if pikachu == nil then pikachu = {} end
pikachu.wpnsnds = {}

pikachu.wpnsnds.wpntable = {
	[1] = "pikachu/wpn_deploy/usp_deploy.ogg",
	[2] = "pikachu/wpn_deploy/glock_deploy.ogg",
	[3] = "pikachu/wpn_deploy/deagle_deploy.ogg",
	[4] = "pikachu/wpn_deploy/p228_deploy.ogg",
	[5] = "pikachu/wpn_deploy/elite_deploy.ogg",
	[6] = "pikachu/wpn_deploy/fiveseven_deploy.ogg",
	[10] = "pikachu/wpn_deploy/m3_deploy.ogg",
	[11] = "pikachu/wpn_deploy/deagle_deploy.ogg",
	[20] = "pikachu/wpn_deploy/mp5_deploy.ogg",
	[22] = "pikachu/wpn_deploy/p90_deploy.ogg",
	[23] = "pikachu/wpn_deploy/mac10_deploy.ogg",
	[30] = "pikachu/wpn_deploy/ak47_deploy.ogg",
	[31] = "pikachu/wpn_deploy/sg552_deploy.ogg",
	[32] = "pikachu/wpn_deploy/m4a1_deploy.ogg",
	[33] = "pikachu/wpn_deploy/aug_deploy.ogg",
	[34] = "pikachu/wpn_deploy/scout_deploy.ogg",
	[35] = "pikachu/wpn_deploy/awp_deploy.ogg",
	[38] = "pikachu/wpn_deploy/galil_deploy.ogg",
	[39] = "pikachu/wpn_deploy/famas_deploy.ogg",
	[40] = "pikachu/wpn_deploy/m249_deploy.ogg",
	[50] = "pikachu/wpn_deploy/knife_deploy.ogg",
	[51] = "pikachu/wpn_deploy/he_deploy.ogg",
	[52] = "pikachu/wpn_deploy/he_deploy.ogg",
	[53] = "pikachu/wpn_deploy/he_deploy.ogg",
	[90] = "pikachu/wpn_deploy/m249_deploy.ogg",
	[91] = "pikachu/wpn_deploy/ak47_deploy.ogg",
}

pikachu.wpnsnds.teamonly = true -- Teammates only?
pikachu.wpnsnds.teamrange = 300 -- Distance check in pixels
pikachu.wpnsnds.teamspec = true -- Extend to dead players spectating?

-- Nothing to config past here

pikachu.wpnsnds.lastwpn = {}

-- Check if setting is valid
pikachu.wpnsnds.dist = pikachu.wpnsnds.teamrange
if type(pikachu.wpnsnds.dist) ~= "number" then
	-- If not number use default of 300px
	pikachu.wpnsnds.dist = 300
elseif pikachu.wpnsnds.dist < 1 then
	-- Rubberband number to at least 1px
	pikachu.wpnsnds.dist = 1
end

function pikachu.wpnsnds.soundpos(id,t)
	if player(id,"team") > 0 and player(id,"health") > 0 then
		-- Check for surrounding allies
		local ptab, ttab = player(0,"table"), closeplayers(player(id,"x"),player(id,"y"),pikachu.wpnsnds.dist,math.min(player(id,"team"),2))
		for _, i in ipairs(ttab) do
			parse("sv_sound2 "..i.." \""..pikachu.wpnsnds.wpntable[t].."\"")
			-- Now check for all spectators spectating the person switching weapon and his/her allies
			if pikachu.wpnsnds.teamspec then
				for _, k in ipairs(ptab) do
					if player(k,"health") == 0 and player(k,"spectating") == i then
						parse("sv_sound2 "..k.." \""..pikachu.wpnsnds.wpntable[t].."\"")
					end
				end
			end
		end
	end
end

addhook("select","pikachu.wpnsnds.call")
function pikachu.wpnsnds.call(id,t)
	if pikachu.wpnsnds.lastwpn[id] ~= t and pikachu.wpnsnds.wpntable[t] ~= nil then
		if pikachu.wpnsnds.teamonly then
			pikachu.wpnsnds.soundpos(id,t)
		else
			parse("sv_soundpos \""..pikachu.wpnsnds.wpntable[t].."\" "..player(id,"x").." "..player(id,"y"))
		end
	end
	pikachu.wpnsnds.lastwpn[id] = t
end

addhook("buy","pikachu.wpnsnds.call2p1")
addhook("spawn","pikachu.wpnsnds.call2p1")
addhook("drop","pikachu.wpnsnds.call2p1")
function pikachu.wpnsnds.call2p1(id)
	-- 10ms timer for checking player's equipped weapon
	timer(10,"pikachu.wpnsnds.call2p2",id)
end

function pikachu.wpnsnds.call2p2(id)
	id = tonumber(id)
	if pikachu.wpnsnds.lastwpn[id] == nil then
		-- spawn initizaltion, if variable was nil due to death or player join
		pikachu.wpnsnds.lastwpn[id] = 0
	end
	local t = player(id,"weapontype")
	pikachu.wpnsnds.call(id,t)
end

addhook("die","pikachu.wpnsnds.reset")
addhook("leave","pikachu.wpnsnds.reset")
function pikachu.wpnsnds.reset(victimid)
	pikachu.wpnsnds.lastwpn[victimid] = nil
end

addhook("bombplant","pikachu.wpnsnds.bombplant")
function pikachu.wpnsnds.bombplant(id)
	parse("sv_soundpos \"pikachu/wpn_deploy/c4_plant.ogg\" "..player(id,"x").." "..player(id,"y"))
end